from PyQt5 import Qt

class OverlayGS(Qt.QGraphicsScene):
    def __init__(self, overlayed_scene):
        super().__init__()
        self.overlayed_scene = overlayed_scene

    def eventFilter(self, watched, event):
        print(watched, type(event))
        if watched is self.overlayed_scene and issubclass(type(event), (Qt.QGraphicsSceneEvent, Qt.QKeyEvent, Qt.QFocusEvent, Qt.QTimerEvent)) or type(event) is Qt.QEvent and event.type() is Qt.QEvent.MetaCall:
#           if hasattr(event, 'screenPos') and issubclass(type(event), Qt.QGraphicsSceneEvent):
#               event.setScenePos(event.widget().mapFromGlobal(event.screenPos()))
            # Without the above, which would require exposing QGraphicsScene*Event.setScenePos functions,
            # OverlayedGV.overlay_item receives correct mouse events only when OverlayedGV.transform is
            # identity.
            return self.event(event)
        else:
            return super().eventFilter(watched, event)

class OverlayedGV(Qt.QGraphicsView):
    def __init__(self, scene, parent=None):
        super().__init__(scene, parent)
        self.setMouseTracking(True)
        self.overlay_scene = OverlayGS(scene)
        self.overlay_item_widget = Qt.QTextEdit('hello world\n'*4)
        self.overlay_item = self.overlay_scene.addWidget(self.overlay_item_widget)
        self.overlay_item.show()
        self.overlay_scene.changed.connect(self.scene().invalidate)

    def resizeEvent(self, event):
        super().resizeEvent(event)
        size = self.size()
        self.overlay_scene.setSceneRect(0, 0, size.width(), size.height())

    def drawForeground(self, p, rect):
        p.save()
        p.resetTransform()
        try:
            self.overlay_scene.render(p)
        finally:
            p.restore()

if __name__ == '__main__':
    import sys
    app = Qt.QApplication(sys.argv)
    scene = Qt.QGraphicsScene()
    scene.setBackgroundBrush(Qt.QBrush(Qt.QColor(Qt.Qt.black)))
    big_box_item = scene.addRect(10, 10, 300, 300, Qt.QPen(Qt.QColor(Qt.Qt.blue)), Qt.QBrush(Qt.QColor(Qt.Qt.red)))
    overlayed_gv = OverlayedGV(scene)
    scene.installEventFilter(overlayed_gv.overlay_scene)
    overlayed_gv.show()
    app.exec()
